/* Create a simple linked list that can be initialized,
 * accessed, and have elements appended to the end
 *
 */

#include <stdio.h>
#include <stdlib.h>


// Create a node
struct Node {
    unsigned long data;
    struct Node *next;
};

// Create the linked list, head is the first element
struct List {
    struct Node *head;
    size_t size_of_type;
};

// Initialize an empty list
struct List *initList(size_t size_of_type) {
    struct List *list = malloc(sizeof(struct List));
    if (list == NULL) {
        perror("failed initialization");
        exit(1);
    }
    list->head = NULL;
    list->size_of_type = size_of_type;
    return list;
}

// Access element at specified index, return the data, -1 if out of bounds
unsigned long getElemIndex(struct List *list, int idx) {
    struct Node *node = list->head;
    int curIdx = 0;
    while(node) {
        if (curIdx == idx) {
            return node->data;
        }
        curIdx++;
        node = node->next;
    }
    return -1;
}

// Append element data to the end of list
struct Node *addEnd(struct List *list, unsigned long data) {

    // empty list
    if (list->head == NULL) {
        struct Node *h = malloc(sizeof(struct Node));
        h->data = data;
        list->head = h;
        return h;
    } else {
        // find the end of the list
        struct Node *node = list->head;
        while (node->next) {
            node = node->next;
        }

        struct Node *toAdd = malloc(sizeof(struct Node));
        if (toAdd == NULL) {
            perror("create node failed");
            exit(1);
        }
        node->next = toAdd;
        toAdd->data = data;
        return toAdd;
    }
}




#ifdef BUILD_TEST
int main(){

}
#endif







